#!/usr/bin/perl -w

use strict;
use POSIX qw(strftime);

my $basedir = "/users/tjabo/Ticker/jan2000";

print "Heise-Grabber Jan2000\n\n";

my $marke1 = 0; # 0, 1, 2
my @dayline;
my $z = "";
my $logfile = "$basedir/ticker.log";

open (LOG, ">>$logfile");
print LOG strftime("%Y %m %d (%a) %H:%M:%S", gmtime) . ": grab2.pl active.\n";


system("rm -f $basedir/index.html");
system("/usr/bin/wget http://www.heise.de/newsticker/ -O $basedir/index.html");

# -----------------------------------------------------------------------

my @empfaenger;
open(EMPF, "<$basedir/empfaenger.lst") || die "kann empfaenger.lst nicht lesen!";
while (<EMPF>) {
    chomp($z = $_);
    if ((length($z) > 0) && (!($z =~ /^\#/))) {
        push(@empfaenger, $z);
    }
}
close(EMPF);

# -----------------------------------------------------------------------

my %besucht;
open(BESUCHT, "<$basedir/besucht.lst") || die "kann besucht.lst nicht lesen!";
while (<BESUCHT>) {
    chomp($z = $_);
    if (length($z) > 0) {
        $besucht{$z} = 1;
    }
}
close(BESUCHT);

# -----------------------------------------------------------------------

open (MAIN, "<$basedir/index.html") || die "Kein newsticker - index.html!";
while (<MAIN>) {

  if ($_ =~ /^<P><B>[0-9][0-9]\./) {
    chomp($z = $_);
    push(@dayline,$z);
  }
}
close(MAIN);
system("rm -f $basedir/index.html");

# --------------------------------------------

my $grabcnt = 0;

foreach my $line (@dayline) {
    my $zeile = $line;
    my $url;
    #    while ( $zeile =~ m/<A HREF="([\"\/a-zA-Z0-9\-\.]+)"/g ) {
    while ( $zeile =~ m/<A HREF=\"([\"\/a-zA-Z0-9\-\.]+)\">/g ) {
        $url = $1;
        if (! defined($besucht{$url})) {
            $besucht{$url} = 1;
            
            $grabcnt++;

            print "Zu saugen: $url\n";
            my $fname = "grabbed$grabcnt.html";

            print LOG strftime("%Y %m %d (%a) %H:%M:%S", gmtime) . ": processing $url ...\n";
            system("/usr/bin/wget http://www.heise.de$url -O $basedir/$fname");

            ProcessGrabbedPage($grabcnt,@empfaenger);
            system("rm -f $basedir/$fname");

        }
    }
}

print LOG strftime("%Y %m %d (%a) %H:%M:%S", gmtime) . ": processed $grabcnt new pages.\n";


# Sichern der besuchten Adressen:
open (OUT, ">$basedir/besucht.lst") || die "Kann liste der besuchten urls nicht sichern!";
foreach my $adresse (keys %besucht) {
    print OUT "$adresse\n";
}
close(OUT);

print LOG strftime("%Y %m %d (%a) %H:%M:%S", gmtime) . ": grab2.pl inactive.\n";
print LOG "----------------------------------------------------------------------------\n";
close(LOG);
#
###############################################################

sub ProcessGrabbedPage { my ($num,@empf) = @_;

    my $fname = "grabbed$num.html";

    my $mailfile = "mailtext.txt";
    my $htmlfile = "mailtext.html";

    my $titel = "[Unbekannt]";
    
    print "Processing: $fname\n";
    my $wo = 0; # 0,1,2
    open(SRC, "<$basedir/$fname") || die "fehler";

    system("rm -f $basedir/$htmlfile");
    open(MTXT, ">$basedir/$htmlfile") || die "konnte $basedir/$htmlfile nicht erzeugen";
    while(<SRC>) {

        if ($_ =~ /<META NAME=\"titel\" CONTENT=\"(.*)\">$/) {
            $titel = $1;
        }
        
        if ($wo == 0) {
            if ($_ =~ /^<HEISETEXT>/) {
                $wo = 1;
            }
        }
        elsif ($wo == 1) {
            if ($_ =~ /^<\/HEISETEXT>/) {
                $wo = 2;
            }
            else {
                print MTXT $_;
            }
            
        }
        next if ($wo == 2);
    }
    close(SRC);
    close(MTXT);
    system("lynx -dump $basedir/$htmlfile > $basedir/$mailfile");
 
    # Titel: HTML-Codes entfernen:
    $titel = ErsetzeDiesDurchDas($titel,"&uuml;","ue");
    $titel = ErsetzeDiesDurchDas($titel,"&Uuml;","Ue");
    $titel = ErsetzeDiesDurchDas($titel,"&auml;","ae");
    $titel = ErsetzeDiesDurchDas($titel,"&Auml;","Ae");
    $titel = ErsetzeDiesDurchDas($titel,"&ouml;","oe");
    $titel = ErsetzeDiesDurchDas($titel,"&Ouml;","Oe");
    $titel = ErsetzeDiesDurchDas($titel,"&szlig;","ss");

    foreach my $person (@empf) {
        system("/bin/mail \"$person\" -s \"HEISE: $titel\" <$basedir/$mailfile");
    }
}

# ---------------------------------------------------------------------

sub ErsetzeDiesDurchDas { my ($wodrin,$dies,$das) = @_;
  my $erg = "";                              # blabla&uuml;schnorg
                                             # 012345678901234
                                             #       6
  while (index($wodrin,$dies) >= 0) {
    my $wo = index($wodrin,$dies);
    $erg = $wodrin;
    $wodrin = substr($erg,0,$wo) . $das . substr($erg,$wo+length($dies));
  }

  return $wodrin;
}
# ---------------------------------------------------------------------
